# frozen_string_literal: true

# Copyright 2020 Google LLC
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     https://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

# Auto-generated by gapic-generator-ruby. DO NOT EDIT!


module Google
  module Cloud
    module ServiceDirectory
      module V1beta1
        # An individual service. A service contains a name and optional metadata.
        # A service must exist before
        # {::Google::Cloud::ServiceDirectory::V1beta1::Endpoint endpoints} can be
        # added to it.
        # @!attribute [rw] name
        #   @return [::String]
        #     Immutable. The resource name for the service in the format
        #     'projects/*/locations/*/namespaces/*/services/*'.
        # @!attribute [rw] metadata
        #   @return [::Google::Protobuf::Map{::String => ::String}]
        #     Optional. Metadata for the service. This data can be consumed by service
        #     clients.  The entire metadata dictionary may contain up to 2000 characters,
        #     spread across all key-value pairs. Metadata that goes beyond any these
        #     limits will be rejected.
        # @!attribute [r] endpoints
        #   @return [::Array<::Google::Cloud::ServiceDirectory::V1beta1::Endpoint>]
        #     Output only. Endpoints associated with this service. Returned on LookupService.Resolve.
        #     Control plane clients should use RegistrationService.ListEndpoints.
        class Service
          include ::Google::Protobuf::MessageExts
          extend ::Google::Protobuf::MessageExts::ClassMethods

          # @!attribute [rw] key
          #   @return [::String]
          # @!attribute [rw] value
          #   @return [::String]
          class MetadataEntry
            include ::Google::Protobuf::MessageExts
            extend ::Google::Protobuf::MessageExts::ClassMethods
          end
        end
      end
    end
  end
end
